--- SQLDisconnect.c	Tue Dec 28 15:05:01 1999
+++ ../../unixODBC-1.8.5.save/DriverManager/SQLDisconnect.c	Tue Feb 22 10:14:02 2000
@@ -271,6 +271,12 @@
                 connection -> msg );
     }
 
+    /*
+     * now clean up any statements that are left about
+     */
+
+    __clean_stmt_from_dbc( connection );
+
     thread_release( SQL_HANDLE_DBC, connection );
 
     return function_return( connection, ret );
--- __handles.c	Sat Dec 11 13:01:57 1999
+++ ../../unixODBC-1.8.5.save/DriverManager/__handles.c	Tue Feb 22 09:45:00 2000
@@ -506,6 +506,56 @@
 }
 
 /*
+ * clear all statements on a DBC
+ */
+
+int __clean_stmt_from_dbc( DMHDBC connection )
+{
+    DMHSTMT ptr = statement_root, last;
+    int ret = 0;
+
+    mutex_entry( &mutex_lists );
+    last = NULL;
+
+    while( ptr )
+    {
+        if ( ptr -> connection == connection )
+        {
+            if ( last )
+            {
+                last -> next_class_list = ptr -> next_class_list;
+            }
+            else
+            {
+                statement_root = ptr -> next_class_list;
+            }
+            clear_error_head( &ptr -> error );
+
+#ifdef HAVE_LIBPTHREAD
+            pthread_mutex_destroy( &ptr -> mutex );
+#endif
+            free( ptr );
+
+            /*
+             * go back to the start
+             */
+
+            last = NULL;
+            ptr = statement_root;
+        }
+        else
+        {
+            last = ptr;
+            ptr = ptr -> next_class_list;
+        }
+    }
+
+    mutex_exit( &mutex_lists );
+
+    return ret;
+}
+
+/*
  * check that a statement is real
  */
 
